// Code generated by sqlc. DO NOT EDIT.
// versions:
//   sqlc v1.25.0
// source: account_entries.sql

package db

import (
	"context"
	"database/sql"
)

const createAccount_entry = `-- name: CreateAccount_entry :one
INSERT INTO account_entries (
    account_id,
    amount
) VALUES (
    $1, $2
) RETURNING id, account_id, amount, created_at
`

type CreateAccount_entryParams struct {
	AccountID int64         `json:"account_id"`
	Amount    sql.NullInt64 `json:"amount"`
}

func (q *Queries) CreateAccount_entry(ctx context.Context, arg CreateAccount_entryParams) (AccountEntries, error) {
	row := q.db.QueryRowContext(ctx, createAccount_entry, arg.AccountID, arg.Amount)
	var i AccountEntries
	err := row.Scan(
		&i.ID,
		&i.AccountID,
		&i.Amount,
		&i.CreatedAt,
	)
	return i, err
}

const deleteAccount_entry = `-- name: DeleteAccount_entry :exec
DELETE FROM accounts WHERE id = $1
`

func (q *Queries) DeleteAccount_entry(ctx context.Context, id int64) error {
	_, err := q.db.ExecContext(ctx, deleteAccount_entry, id)
	return err
}

const getAccount_entry = `-- name: GetAccount_entry :one
SELECT id, account_id, amount, created_at FROM account_entries
WHERE id = $1 LIMIT 1
`

func (q *Queries) GetAccount_entry(ctx context.Context, id int64) (AccountEntries, error) {
	row := q.db.QueryRowContext(ctx, getAccount_entry, id)
	var i AccountEntries
	err := row.Scan(
		&i.ID,
		&i.AccountID,
		&i.Amount,
		&i.CreatedAt,
	)
	return i, err
}

const listAccount_entries = `-- name: ListAccount_entries :many
SELECT id, account_id, amount, created_at FROM account_entries
WHERE account_id = $1
ORDER BY id
LIMIT $2
OFFSET $3
`

type ListAccount_entriesParams struct {
	AccountID int64 `json:"account_id"`
	Limit     int64 `json:"limit"`
	Offset    int64 `json:"offset"`
}

func (q *Queries) ListAccount_entries(ctx context.Context, arg ListAccount_entriesParams) ([]AccountEntries, error) {
	rows, err := q.db.QueryContext(ctx, listAccount_entries, arg.AccountID, arg.Limit, arg.Offset)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []AccountEntries
	for rows.Next() {
		var i AccountEntries
		if err := rows.Scan(
			&i.ID,
			&i.AccountID,
			&i.Amount,
			&i.CreatedAt,
		); err != nil {
			return nil, err
		}
		items = append(items, i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const updateAccount_entry = `-- name: UpdateAccount_entry :exec
UPDATE account_entries 
SET amount = $2
WHERE id = $1
`

type UpdateAccount_entryParams struct {
	ID     int64         `json:"id"`
	Amount sql.NullInt64 `json:"amount"`
}

func (q *Queries) UpdateAccount_entry(ctx context.Context, arg UpdateAccount_entryParams) error {
	_, err := q.db.ExecContext(ctx, updateAccount_entry, arg.ID, arg.Amount)
	return err
}
